--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/cnc1900_nand.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/cnc1900_nand.c	2014-10-23 20:22:19.978715000 +0800
@@ -0,0 +1,242 @@
+/*
+ *  drivers/mtd/nand/xx.c
+ *
+ *  Copyrigth (C) 2010 Celestial Semiconductor
+ *                2011 Cavium
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/nand.h>
+#include <linux/mtd/nand_ecc.h>
+#include <linux/mtd/partitions.h>
+#include <linux/platform_device.h>
+
+#include <mach/nand.h>
+
+struct plat_runtime {
+	struct plat_cncnand_port *cur;
+	struct plat_cncnand_port *ports;
+};
+
+static void cnc_nand_hwctl(struct mtd_info *mtd, int mode)
+{
+	struct nand_chip *nand = mtd->priv;
+	struct plat_runtime *runtime = nand->priv;
+
+	if (mode == NAND_ECC_READ)
+		__raw_writel(runtime->cur->membase + (nand->IO_ADDR_R - runtime->cur->mapbase),
+			runtime->cur->reg_base + ECC_ADDRESS);
+
+	if (mode == NAND_ECC_WRITE)
+		__raw_writel(runtime->cur->membase + (nand->IO_ADDR_W - runtime->cur->mapbase),
+			runtime->cur->reg_base + ECC_ADDRESS);
+}
+
+/*
+ * Read hardware ECC value and pack into three bytes
+ */
+static int cnc_nand_calculate(struct mtd_info *mtd,
+		const u_char *dat, u_char *ecc_code)
+{
+	struct nand_chip *nand = mtd->priv;
+	struct plat_runtime *runtime = nand->priv;
+	unsigned int ecc = __raw_readl(runtime->cur->reg_base + ECC_CODE);
+
+	ecc_code[0] = (u_char)(ecc);
+	ecc_code[1] = (u_char)(ecc >> 8);
+	ecc_code[2] = (u_char)(ecc >> 16);
+	return 0;
+}
+
+static int cnc_nand_dev_ready(struct mtd_info *mtd)
+{
+	struct nand_chip *nand = mtd->priv;
+	struct plat_runtime *runtime = nand->priv;
+	unsigned int st = __raw_readl(runtime->cur->reg_base + STATUS);
+
+	return st & STATUS_READY;
+}
+
+static void cnc_nand_read_buf(struct mtd_info *mtd, u8 *buf, int len)
+{
+	struct nand_chip *nand = mtd->priv;
+
+	if (len % 4)
+		__raw_readsb(nand->IO_ADDR_R, buf, len);
+	else
+		__raw_readsl(nand->IO_ADDR_R, buf, len / 4);
+}
+
+static void cnc_nand_write_buf(struct mtd_info *mtd, const u8 *buf, int len)
+{
+	struct nand_chip *nand = mtd->priv;
+
+	if (len % 4)
+		__raw_writesb(nand->IO_ADDR_W, buf, len);
+	else
+		__raw_writesl(nand->IO_ADDR_W, buf, len / 4);
+}
+
+static void cnc_nand_cmd_ctrl(struct mtd_info *mtd, int cmd, unsigned int ctrl)
+{
+	struct nand_chip *nand = mtd->priv;
+	struct plat_runtime *runtime = nand->priv;
+	unsigned int addr = (u32)runtime->cur->mapbase;
+
+	if (ctrl & NAND_CTRL_CHANGE) {
+		if (ctrl & NAND_CLE)
+			addr |= runtime->cur->cle;
+		if (ctrl & NAND_ALE)
+			addr |= runtime->cur->ale;
+
+		nand->IO_ADDR_W = (void *)addr; 
+	}
+
+	if (cmd != NAND_CMD_NONE)
+		iowrite8(cmd, nand->IO_ADDR_W);
+}
+
+static void cnc_nand_select_chip(struct mtd_info *mtd, int chip)
+{
+	struct nand_chip *nand = mtd->priv;
+	struct plat_runtime *runtime = nand->priv;
+	unsigned int cfg0 = 0;
+
+	if (chip >= 0) {
+		runtime->cur = runtime->ports + chip;
+		nand->IO_ADDR_R = nand->IO_ADDR_W = runtime->cur->mapbase;
+		cfg0 = __raw_readl(runtime->cur->reg_port + CEN_CFG_0);
+		__raw_writel(cfg0 | FORCE_CE_LOW, runtime->cur->reg_port + CEN_CFG_0);
+	} else if (runtime->cur) {
+		cfg0 = __raw_readl(runtime->cur->reg_port + CEN_CFG_0);
+		__raw_writel(cfg0 & ~FORCE_CE_LOW, runtime->cur->reg_port + CEN_CFG_0);
+		nand->IO_ADDR_R = nand->IO_ADDR_W = runtime->cur = NULL;
+	}
+}
+
+static int __init cnc_nand_probe(struct platform_device *pdev)
+{
+	struct plat_cncnand_port *p = pdev->dev.platform_data;
+	struct mtd_info *mtd = NULL;
+	struct nand_chip *nand = NULL;
+	struct plat_runtime *runtime = NULL;
+	int chips = 0, ret = 0;
+
+	for (; p && p->membase; p++, chips++) {
+		p->mapbase = ioremap(p->membase, SZ_8M);
+		if (!p->mapbase) {
+			dev_err(&pdev->dev, "ioremap failed\n");
+			ret = -EINVAL;
+			goto err;
+		}
+	}
+
+	if (!chips)
+		return -ENODEV;
+
+	mtd = (struct mtd_info *)kzalloc(sizeof(struct mtd_info), GFP_KERNEL);
+	nand = (struct nand_chip *)kzalloc(sizeof(struct nand_chip), GFP_KERNEL);
+	runtime = (struct plat_runtime *)kzalloc(sizeof(struct plat_runtime), GFP_KERNEL);
+	if (!mtd || !nand || !runtime) {
+		dev_err(&pdev->dev, "unable to allocate memory\n");
+		ret = -ENOMEM;
+		goto err;
+	}
+
+	mtd->priv = nand;
+	nand->priv = runtime;
+	runtime->ports = pdev->dev.platform_data;
+	platform_set_drvdata(pdev, mtd);
+
+	mtd->name		= dev_name(&pdev->dev);
+	mtd->owner		= THIS_MODULE;
+	nand->numchips  = chips;
+	nand->bbt_options = NAND_BBT_USE_FLASH;
+
+	/* Set address of hardware control function */
+	nand->select_chip = cnc_nand_select_chip;
+	nand->cmd_ctrl	  = cnc_nand_cmd_ctrl;
+	nand->dev_ready	  = cnc_nand_dev_ready;
+
+	/* Speed up buffer I/O */
+	nand->read_buf    = cnc_nand_read_buf;
+	nand->write_buf   = cnc_nand_write_buf;
+
+	/* Use board-specific ECC config */
+	nand->ecc.mode      = NAND_ECC_HW;
+	nand->ecc.hwctl     = cnc_nand_hwctl;
+	nand->ecc.calculate = cnc_nand_calculate;
+	nand->ecc.correct   = nand_correct_data;
+	nand->ecc.size      = 512;
+	nand->ecc.bytes     = 3;
+
+	ret = nand_scan(mtd, nand->numchips);
+	if (ret < 0) {
+		dev_err(&pdev->dev, "no NAND chip(s) found\n");
+		goto err;
+	}
+
+    return mtd_device_parse_register(mtd, NULL, NULL, NULL, 0);
+
+err:
+	for (p = pdev->dev.platform_data; p && p->mapbase; p++) {
+		if (p->mapbase)
+			iounmap(p->mapbase);
+	}
+	if (mtd)
+		kfree(mtd);
+	if (nand)
+		kfree(nand);
+	if (runtime)
+		kfree(runtime);
+	return ret;
+}
+
+static int __exit cnc_nand_remove(struct platform_device *pdev)
+{
+	struct plat_cncnand_port *p = pdev->dev.platform_data;
+	struct mtd_info *mtd = platform_get_drvdata(pdev);
+	for (; p && p->mapbase; p++) {
+		if (p->mapbase)
+			iounmap(p->mapbase);
+	}
+
+	nand_release(mtd);
+	kfree(mtd->priv);
+	kfree(mtd);
+	return 0;
+}
+
+static struct platform_driver cnc_nand_driver = {
+	.remove		= __exit_p(cnc_nand_remove),
+	.driver		= {
+		.name	= "cnc-nand",
+		.owner	= THIS_MODULE,
+	},
+};
+
+static int __init cnc_nand_init(void)
+{
+	return platform_driver_probe(&cnc_nand_driver, cnc_nand_probe);
+}
+
+static void __exit cnc_nand_exit(void)
+{
+	platform_driver_unregister(&cnc_nand_driver);
+}
+
+module_init(cnc_nand_init);
+module_exit(cnc_nand_exit);
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("xiaodong fan <xiaodong.fan@caviumnetworks.com>");
+MODULE_DESCRIPTION("NAND flash driver for Cavium celestial SOC");
+MODULE_ALIAS("platform:cnc-nand");
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/eth.c linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/eth.c
